#

# The files themselves are in several subdirectories and need to be prefixed wit this.

%global archive_path libraries/lib%{name}

# Archive from GitLab tag contains the commit hash in the top-level directory name
%global commit_hash 3c9aa9df8497ad977e0f91347f0626f5d53c9ab7

Summary:        Memory-mapped key-value database
Name:           lmdb
Version:        0.9.27
Release:        %mkrel 1
License:        GPLv2+
Group:          System/Base
URL:            http://symas.com/mdb/
Source0:        https://git.openldap.org/openldap/openldap/-/archive/LMDB_%{version}.tar.xz
Source1:        lmdb.pc.in
Patch0:         lmdb-make.patch

BuildRequires:  doxygen

%description
LMDB is an ultra-fast, ultra-compact key-value embedded data
store developed by for the OpenLDAP Project. By using memory-mapped files,
it provides the read performance of a pure in-memory database while still
offering the persistence of standard disk-based databases, and is only limited
to the size of the virtual address space.

%files
%{_bindir}/*
%{_mandir}/man1/*

#--------------------------------------------------------------------

%define major 0
%define liblmdb %mklibname lmdb %{major}

%package -n %{liblmdb}
Summary:        Memory-mapped key-value database
Group:          System/Libraries

%description -n %{liblmdb}
LMDB is an ultra-fast, ultra-compact key-value embedded data
store developed by for the OpenLDAP Project. By using memory-mapped files,
it provides the read performance of a pure in-memory database while still
offering the persistence of standard disk-based databases, and is only limited
to the size of the virtual address space.

%files -n %{liblmdb}
%{_libdir}/liblmdb.so.%{major}*

#--------------------------------------------------------------------

%define lmdb_devel %mklibname lmdb -d

%package -n %{lmdb_devel}
Summary:        Devel stuff for %{name}
Group:          Development/Libraries
Requires:       %{liblmdb} = %{version}-%{release}
Provides:       %{name}-devel = %{version}-%{release}

%description -n %{lmdb_devel}
This package contains header files needed if you wish to build applications
based on %{name}.

%files -n %{lmdb_devel}
%{_libdir}/liblmdb.so
%{_libdir}/pkgconfig/*.pc
%{_includedir}/*.h

#--------------------------------------------------------------------


%prep
%setup -qn openldap-LMDB_%{version}-%{commit_hash}
%apply_patches

%build
pushd %{archive_path}
%make_build
doxygen
rm -f Doxyfile
rm -rf man # Doxygen generated manpages
popd

%install
pushd %{archive_path}
# make install expects existing directory tree
mkdir -m 0755 -p %{buildroot}{%{_bindir},%{_includedir}}
mkdir -m 0755 -p %{buildroot}{%{_libdir}/pkgconfig,%{_mandir}/man1}

%make_install prefix=%{_prefix} libdir=%{_libdir} mandir=%{_mandir}
popd

# Install pkgconfig file
sed -e 's:@PREFIX@:%{_prefix}:g' \
    -e 's:@EXEC_PREFIX@:%{_exec_prefix}:g' \
    -e 's:@LIBDIR@:%{_libdir}:g' \
    -e 's:@INCLUDEDIR@:%{_includedir}:g' \
    -e 's:@PACKAGE_VERSION@:%{version}:g' \
    %{SOURCE1} >lmdb.pc
install -Dpm 0644 -t %{buildroot}%{_libdir}/pkgconfig lmdb.pc


%changelog
* Tue Feb 16 2021 tex - 0.9.27-1pclos2021
- new version
